declare module "code-mirror" {
    import { type ICustomElementViewModel } from 'aurelia';
    import 'codemirror/mode/javascript/javascript';
    import 'codemirror/mode/cmake/cmake';
    import 'codemirror/addon/hint/show-hint';
    import 'codemirror/addon/hint/javascript-hint';
    /**
     * CodeMirror
     */
    export class CodeMirror implements ICustomElementViewModel {
        private readonly _element;
        private _codeMirror;
        codeArea: HTMLDivElement;
        /** Code */
        code: string;
        language: string;
        theme: string;
        suggestions: Array<{
            term: string | RegExp;
            values: string[];
        }>;
        readOnly: boolean;
        lineNumbers: boolean;
        autofocus: boolean;
        private _boundedChange;
        private _boundedFocus;
        constructor(_element: HTMLElement);
        attached(): void | Promise<void>;
        codeChanged(newValue: string, oldValue: string): void;
        /** Set the cursor at the end of existing content */
        private _setCursorAtEnd;
        private _hintFunction;
        detaching(): void | Promise<void>;
    }
}
declare module "index" {
    export { CodeMirror } from "code-mirror";
}

declare module "@aegenet/au2-code-mirror-5" {
    export * from "src/index";
}
